<?php
// GlobeWeather module - retrieving URL page content with FILE_GET_CONTENTS()
// $Id: mod_globeweather/helpers/metar_http1.php 22-07-2018 00:00Z robj $
// (C)2010-2018 INNATO BV - www.innato.nl
// @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
// **************************************************************************
// A metar station weather fetching module for Joomla! 3.x by Innato B.V.
// **************************************************************************

// ensure this file is being included by a parent file
defined( '_JEXEC' ) or die( 'Restricted access' );
		
if ($_SESSION['metar_http1_option']) {
	// HTTP1 technology by Innato 2010 - updated 2018
	$_SESSION['metar_mode_actual'] = 'HTTP2 NOK';
	$metar = '';
	
	$protocol = 'https://';
	$host = 'aviationweather.gov';
	$location = "/metar/data?ids=$station&format=raw";
	$url = $protocol.$host.$location;
		
	if ($metar = @file_get_contents($url)) {
		if (preg_match("/($station [0-9]{6}Z .+)/", $metar, $matches)) {
			$metar_beginpos_pointer = stripos($metar, "<!-- Data starts here -->") + 5;	// to make sure we do not have the '<!--' in the metar string
			$metar_endpos_pointer = stripos($metar, "<!-- Data ends here -->") + 5;	// make sure we do always have a '<' char at the end, maybe from <br /> or <hr or ...
			$metar_length = $metar_endpos_pointer - $metar_beginpos_pointer;
			$metar = substr($metar, $metar_beginpos_pointer, $metar_length);
			// let's first filter out all non-metar chars
			$metar = preg_replace('@[^a-zA-Z0-9$+\-<>/=\s]@', '', $metar);
			// replace multiple whitespace by one
			$metar = preg_replace('/\s\s+/', ' ', $metar);

			$metar_beginpos_pointer = stripos($metar, $station);
			$metar_endpos_pointer = stripos($metar, "<");
			$metar_length = $metar_endpos_pointer - $metar_beginpos_pointer;
			$metar = substr($metar, $metar_beginpos_pointer, $metar_length);
			// must remove leading and trailing spaces
			$metar = trim($metar, ' ');

			$metar_retrieval_success = true;
			$_SESSION['metar_mode_actual'] = 'HTTP1 OK';
		}
		else {	// HTTP1 station not found
			$_SESSION['metar_mode_actual'] = 'HTTP1 stn not fnd';
		}
	}
	else {	// HTTP1 connection failed - may not work due to UDP socket
		$_SESSION['metar_http1_option'] = false;
		$_SESSION['metar_mode_actual'] = 'HTTP1 conn fld';
	}
}
?>