<?php
// GlobeWeather module - retrieving URL page content with FSOCKOPEN()
// $Id: mod_globeweather/helpers/metar_http2.php 22-07-2018 00:00Z robj $
// (C)2010-2018 INNATO BV - www.innato.nl
// @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
// **************************************************************************
// A metar station weather fetching module for Joomla! 3.x by Innato B.V.
// **************************************************************************

// ensure this file is being included by a parent file
defined( '_JEXEC' ) or die( 'Restricted access' );
	
if ($_SESSION['metar_http2_option']) {
	// HTTP2 technology by Innato 2010 - updated 2018
	$_SESSION['metar_mode_actual'] = 'HTTP2 NOK';
	$metar = '';

	$protocol = 'ssl://';
	$host = 'aviationweather.gov';
	$location = "/metar/data?ids=$station&format=raw";

	$request = "HTTP/1.1\r\n" .
		"If-Modified-Since: Fri, 01 Jan 2010 09:00:00 GMT\r\n" .
		"Pragma: no-cache\r\n" .
		"Cache-Control: no-cache\r\n";
				
	if ($fp = @fsockopen($protocol.$host, 443, $errno, $errstr, 30)) {
		$request = "POST $location $request" .
			"Host: $host\r\n" .
			"Content-Type: text/html; charset=utf-8\r\n" .
			"Content-Length: 9\r\n\r\n" .
			"Connection: Close\r\n\r\n";
	
		if ( @fwrite($fp, $request) ) {
			while ( !@feof($fp) ) {
				$metar .= @fgets($fp, 1024);
			}
		}
	}
	@fclose($fp);

	if ( $metar ) {
		if (preg_match("/($station [0-9]{6}Z .+)/", $metar, $matches)) {
			$metar_beginpos_pointer = stripos($metar, "<!-- Data starts here -->") + 5;	// to make sure we do not have the '<!--' in the metar string
			$metar_endpos_pointer = stripos($metar, "<!-- Data ends here -->") + 5;	// make sure we do always have a '<' char at the end, maybe from <br /> or <hr or ...
			$metar_length = $metar_endpos_pointer - $metar_beginpos_pointer;
			$metar = substr($metar, $metar_beginpos_pointer, $metar_length);
			// let's first filter out all non-metar chars
			$metar = preg_replace('@[^a-zA-Z0-9$+\-<>/=\s]@', '', $metar);
			// replace multiple whitespace by one
			$metar = preg_replace('/\s\s+/', ' ', $metar);

			$metar_beginpos_pointer = stripos($metar, $station);
			$metar_endpos_pointer = stripos($metar, "<");
			$metar_length = $metar_endpos_pointer - $metar_beginpos_pointer;
			$metar = substr($metar, $metar_beginpos_pointer, $metar_length);
			// must remove leading and trailing spaces
			$metar = trim($metar, ' ');

			$metar_retrieval_success = true;
			$_SESSION['metar_mode_actual'] = 'HTTP2 OK';
		}
		else {	// HTTP2 station not found
			$_SESSION['metar_mode_actual'] = 'HTTP2 stn not fnd';
		}
	}
	else {	// HTTP2 connection failed - may not work due to UDP socket
		$_SESSION['metar_http2_option'] = false;
		$_SESSION['metar_mode_actual'] = 'HTTP2 conn fld';
	}
}
?>