<?php
// GlobeWeather module - retrieving URL page content with FILE()
// $Id: mod_globeweather/helpers/metar_http3.php 22-07-2018 00:00Z robj $
// (C)2010-2018 INNATO BV - www.innato.nl
// @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
// **************************************************************************
// A metar station weather fetching module for Joomla! 3.x by Innato B.V.
// **************************************************************************

// ensure this file is being included by a parent file
defined( '_JEXEC' ) or die( 'Restricted access' );

if ($_SESSION['metar_http3_option']) {
	// HTTP3 technology by Innato 2018
	$_SESSION['metar_mode_actual'] = 'HTTP3 NOK';
	$metar = '';
	$metar_array = Array();

	$protocol = 'https://';
	$host = 'aviationweather.gov';
	$location = "/metar/data?ids=$station&format=raw";
	$url = $protocol.$host.$location;

	// using file() function to get content
	$metar_array = @file($url);

	if ( $metar_array[0] != '' ) {
		// turn array into one variable
		$metar = implode('',$metar_array);
		if (preg_match("/($station [0-9]{6}Z .+)/", $metar, $matches)) {
			$metar_beginpos_pointer = stripos($metar, "<!-- Data starts here -->") + 5;	// to make sure we do not have the '<!--' in the metar string
			$metar_endpos_pointer = stripos($metar, "<!-- Data ends here -->") + 5;	// make sure we do always have a '<' char at the end, maybe from <br /> or <hr or ...
			$metar_length = $metar_endpos_pointer - $metar_beginpos_pointer;
			$metar = substr($metar, $metar_beginpos_pointer, $metar_length);
			// let's first filter out all non-metar chars
			$metar = preg_replace('@[^a-zA-Z0-9$+\-<>/=\s]@', '', $metar);
			// replace multiple whitespace by one
			$metar = preg_replace('/\s\s+/', ' ', $metar);

			$metar_beginpos_pointer = stripos($metar, $station);
			$metar_endpos_pointer = stripos($metar, "<");
			$metar_length = $metar_endpos_pointer - $metar_beginpos_pointer;
			$metar = substr($metar, $metar_beginpos_pointer, $metar_length);
			// must remove leading and trailing spaces
			$metar = trim($metar, ' ');

			$metar_retrieval_success = true;
			$_SESSION['metar_mode_actual'] = 'HTTP3 OK';
		}
		else {	// HTTP3 station not found
			$_SESSION['metar_mode_actual'] = 'HTTP3 stn not fnd';
		}
	}
	else {	// HTTP3 connection failed
		$_SESSION['metar_http4_option'] = false;
		$_SESSION['metar_mode_actual'] = 'HTTP3 conn fld';
	}
}
?>